--[[--------------------------------------------------------------------
--	CodeNameBlaze, an ElvUI edit by Blazeflack @ tukui.org
--
--	This file contains changes/additions to various elements in ElvUI
--	that didn't warrant its own module
--------------------------------------------------------------------]]--
local E, L, V, P, G, _ = unpack(ElvUI); --Import: Engine, Locales, PrivateDB, ProfileDB, GlobalDB, Localize Underscore
local M = E:GetModule('Misc');
local CNB = E:GetModule('CodeNameBlaze');

function CNB:SetBubbleColor(frame)	
	--Use separate backdrop color for chat bubbles
	if E.private.general.chatBubbles == 'backdrop' then
		if E.PixelMode then
			frame:SetBackdropColor(unpack(CNB.media.chatbubblecolor))
		else
			frame.backdrop:SetTexture(unpack(CNB.media.chatbubblecolor))
		end
	end
end
hooksecurefunc(M, "SkinBubble", CNB.SetBubbleColor)

function CNB:UpdateExpRepAnchors()
	local repBar = ReputationBarMover
	local expBar = ExperienceBarMover

	if (E:HasMoverBeenMoved('ExperienceBarMover') or E:HasMoverBeenMoved('ReputationBarMover')) or not repBar or not expBar then return; end
	repBar:ClearAllPoints()
	expBar:ClearAllPoints()
	
	if M.expBar:IsShown() then
		expBar:SetPoint('TOP', MMHolder, 'BOTTOM', 1, -1)
		repBar:SetPoint('TOP', M.expBar, 'BOTTOM', 0, -1)
	else
		repBar:SetPoint('TOP', MMHolder, 'BOTTOM', 1, -1)
		expBar:SetPoint('TOP', M.repBar, 'BOTTOM', 0, -1)
	end
end
hooksecurefunc(M, "UpdateExperience", CNB.UpdateExpRepAnchors)
hooksecurefunc(M, "UpdateReputation", CNB.UpdateExpRepAnchors)
hooksecurefunc(M, "EnableDisable_ExperienceBar", CNB.UpdateExpRepAnchors)
hooksecurefunc(M, "LoadExpRepBar", CNB.UpdateExpRepAnchors)

function CNB:UpdateExpRepDimensions()
	--Set width to match minimap width unless user has moved the anchor
	if E:HasMoverBeenMoved('ExperienceBarMover') then
		M.expBar:Width(E.db.general.experience.width)
	else
		M.expBar:Width(E.db.general.minimap.size + E.ConsolidatedBuffsWidth + (E.PixelMode and 1 or 5))
	end

	if E:HasMoverBeenMoved('ReputationBarMover') then
		M.repBar:Width(E.db.general.reputation.width)
	else
		M.repBar:Width(E.db.general.minimap.size + E.ConsolidatedBuffsWidth + (E.PixelMode and 1 or 5))
	end
end
hooksecurefunc(M, "UpdateExpRepDimensions", CNB.UpdateExpRepDimensions)